
import random

def LV(lv):
    out = []
    for i in reversed(lv):
        out.append(str(i))
    return ''.join(out)

SP_LEFT = 3
NUM_ENTRIES = 2 ** ( SP_LEFT + 1 )
assert NUM_ENTRIES == 16, NUM_ENTRIES


def Method_1(row_match):
    should_be = 0
    for i in xrange(NUM_ENTRIES):
        if (row_match >> i) & 1:
            should_be = i
    return should_be

def Method_2(row_match):
    out = 0
    for output_bit in xrange(SP_LEFT + 1):
        A = B = 0
        for row in xrange(1, NUM_ENTRIES, 1):
            di = row & ( 1 << output_bit )
            mask = 1 << row
            if di:
                A |= row_match & mask
                B |= mask
            else:
                B |= (~row_match) & mask

        cout = ((A + B) >> NUM_ENTRIES)
        assert cout in (0, 1)
        out |= cout << output_bit
    return out

for row_match in xrange(0x1ffff):
    assert Method_1(row_match) == Method_2(row_match), row_match
print 'ok'


