
def F(i):
    i = list(i)
    i.sort()
    return i

def Main():
    table = dict()
    total = dict()
    all_rows = set()
    all_columns = set()
    all_sections = []
    for line in file("report1"):
        fields = line.split()
        if len(fields) == 0:
            continue

        zero = fields[ 0 ]
        if zero == '[ENV]':
            section = '%s, %s' % (' '.join(fields[ 1: ]), tex)
            all_sections.append(section)
        elif line.startswith("* Making report"):
            tex = fields[ -1 ]
        elif line.startswith("total time ="):
            total[ section ] = int(fields[ -1 ], 16)
        elif zero in ('[DCT]', '[CC]', '[DCT1]', '[DEC]'):
            row = zero
            all_rows.add(row)
            fields = fields[ 1: ]
            zero = fields[ 0 ]

        if zero in ('global_counter', 'match_count', 
                    'miss_count', 'call_count'):
            table[ (section, row, zero) ] = int(fields[ -1 ], 16)
            all_columns.add(zero)
           
    all_columns = F(all_columns)
    all_rows = F(all_rows)

    out = file("xenon.csv", "wt")

    for column in all_columns:
        out.write(',%s' % column)

    for section in all_sections:
        out.write('\n\n%s\n' % section)
        for row in all_rows:
            out.write('%s,' % row)
            for column in all_columns:
                out.write('%d,' % table[ (section, row, column) ])
            out.write('\n')
        out.write('total, %d\n' % total[ section ])
    out.close()

if __name__ == "__main__":
    Main()

